#include "Appevent.ch"

#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
#include "CommCtrl_constants.ch"
#include "WinUser_constants.ch"

#define  nItemCache    100000

PROCEDURE dbesys ; return
PROCEDURE appsys ; return
// ---------------------------------------------------------------------------
PROCEDURE main
LOCAL oDlg,oDa,oLv
LOCAL hFont,hDC

   SET CHARSET TO ANSI
   SET ALTER TO _LOGFILE.TXT

   oDlg := XbpDialog():new(AppDesktop(),,{0,0}, {640,480},,.F.)
   oDlg:taskList := .T.
   oDlg:title    := "Testing ListView"
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo)}
   oDlg:create()

   oDa  := oDlg:drawingArea
   oDa:ClipChildren := .T.
   oDa:resize := {|p1,p2| oLv:SetSize(p2) }

   oLv := DXE_DataView():New(oDa,,{0,0},oDa:currentSize())
   //
   // use LVS_OWNERDATA
   //
   oLv:dwLvStyle := nOr( oLv:dwLvStyle, LVS_OWNERDATA )
   oLv:Create()

   // Windows Way to use a Font
   hDC := @user32:GetDC(0)
   hFont := @ot4xb:_create_font_(hDC,"Verdana",115,0,0,0)
   @user32:ReleaseDC(0,hDC)
   //
   oLv:lv_SetExtendedListViewStyle( nOr(LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES))
   // set Font to Listview
   @user32:SendMessageA( oLv:hLv, WM_SETFONT , hFont , 0)

   // set Listview Color -> HEX Value
   oLv:lv_SetBkColor(0xc8fde3)
   oLv:lv_SetTextBkColor(0xc8fde3)

   //
   // init Listview
   //
   InitTheListView(oLv)

   //
   // do not use Imagelist
   //
   oLv:UseSystemImageList(.F.)

   //
   // show Listview
   //
   PopulateTheListView(oLv)

   //
   // click on Item -> Eval( bBlock )
   //
   oLv:SetLvNotifyCB( LVN_COLUMNCLICK  , {|o,notify_code,lp| OnColumnClick(o,lp) } )

   //
   // add for LVS_OWNERDATA
   //
   oLv:SetLvNotifyCB( LVN_GETDISPINFO  , {|o,notify_code,lp| OnDISPINFO (o,lp) } )

   //
   // this is need when load Data from DBF / SQL Table
   //
   // not need when use Array, here only to show "Cache"
   //
   oLv:SetLvNotifyCB( LVN_ODCACHEHINT  , {|o,notify_code,lp| OnCACHEHINT(o,lp) } )
   oLv:SetLvNotifyCB( LVN_ODFINDITEM   , {|o,notify_code,lp| OnFINDITEM (o,lp) } )

   SetAppWindow(oDlg)
   SetAppFocus(oDlg)
   CenterControl(oDlg)
   SetAppFocus( oLv )
   oLv:Show()
   oDlg:Show()

   // goTop ( ZERO-based )
   oLv:lv_SetItemState(0,nOr(LVIS_SELECTED,LVIS_FOCUSED),nOr(LVIS_SELECTED,LVIS_FOCUSED))

   MsgLoop()

   SET ALTER TO

RETURN

// ---------------------------------------------------------------------------
STATIC FUNCTION InitTheListView( oLv )
LOCAL n,col

WITH OBJECT oLv
   col := LVCOLUMN():New()
*  .:lv_DeleteAllItems()
   col:mask := nOr( LVCF_FMT,  LVCF_WIDTH , LVCF_TEXT )
   col:fmt  := LVCFMT_LEFT

   n:= 0
   col:cx = 350
   col:cText := "Name"
   .:lv_InsertColumn(n,col)

   col:cText := NIL
END WITH
RETURN NIL

// ---------------------------------------------------------------------------
STATIC FUNCTION PopulateTheListView(oLv)
LOCAL aData   := {}
LOCAL i

   //
   // build 1-Dim Array to show LVN_ODCACHEHINT Event working
   //
   FOR i := 1 TO nItemCache
      AADD(aData,STR(i)+" *")
   NEXT

   //
   // assign Array to iVAR
   //
   oLv:aSource := aData
   //
   // get Memory for (big) Array
   //
   oLv:lv_SetItemCount(nItemCache)

RETURN NIL

// ---------------------------------------------------------------------------
STATIC FUNCTION MsgLoop()
LOCAL nEvt,oo,p1,p2

   nEvt := oo := p1 := p2 := NIL
   WHILE ( nEvt != xbeP_Quit )
      nEvt := AppEvent(@p1,@p2,@oo )
      oo:HandleEvent(nEvt,p1,p2)
   END
RETURN NIL

// ---------------------------------------------------------------------------

FUNCTION OnColumnClick(oLv,lp)
LOCAL st := NMITEMACTIVATE():New()

st:_link_(lp,.F.)
MsgBox( cPrintf(, "\r\niItem       : %i        "+;
                  "\r\niSubItem    : %i        "+;
                  "\r\nuNewState   : 0x%08.8X  "+;
                  "\r\nuOldState   : 0x%08.8X  "+;
                  "\r\nuChanged    : 0x%08.8X  "+;
                  "\r\nptAction:x  : %i        "+;
                  "\r\nptAction:y  : %i        "+;
                  "\r\nlParam      : %i        "+;
                  "\r\nuKeyFlags   : 0x%i      ",;
                  st:iItem         ,;
                  st:iSubItem      ,;
                  st:uNewState     ,;
                  st:uOldState     ,;
                  st:uChanged      ,;
                  st:ptAction:x    ,;
                  st:ptAction:y    ,;
                  st:lParam        ,;
                  st:uKeyFlags     ), "OnColumnClick")
RETURN NIL // default processing

//----------------------------------------------------------------------------

FUNCTION OnDISPINFO(oLv,lp)
LOCAL pItem
LOCAL itemid
LOCAL ctext
LOCAL st := NMLVDISPINFO():New()
LOCAL oError
LOCAL bSaveError

   st:_link_(lp,.F.)

   pItem    := st:item
   //
   // ZERO-based itemid
   //
   itemid   := pItem:iItem
   //
   // use Array
   //
   ctext    := oLv:aSource[itemid+1]

   bSaveError := ErrorBlock()
   ErrorBlock( {|e| Break(e)} )

   BEGIN SEQUENCE
      //
      // Assign Array Text to Display
      //
      pItem:cText       := ctext+CHR(0)

      ondummy("InternalDISPINFO",itemid,ctext)

   RECOVER USING oError
      ErrorBlock( bSaveError )
      //
      // never get here with Errorblock !
      //
      ondummy("Error DISPINFO",itemid,ctext)

   END SEQUENCE
   ErrorBlock( bSaveError )

RETURN 0

FUNCTION OnCACHEHINT(oLv,lp)
//
// this is need when load Data from DBF / SQL Table
//
// not need when use Array
//
LOCAL xhdr
LOCAL nFrom
LOCAL nTo
LOCAL cText
LOCAL st := NMLVCACHEHINT():New()

   st:_link_(lp,.F.)

   xhdr    := st:hdr
   //
   // cache the data pCacheHint->iFrom to pCacheHint->iTo ...
   //
   nFrom   := st:iFrom
   nTo     := st:iTo

   cText := "Cache from "+LTRIM(STR(nFrom))+" to "+LTRIM(STR(nTo))
   ondummy("InternalODCACHEHINT",ctext)

RETURN 0

FUNCTION OnFINDITEM(oLv,lp)
LOCAL st := NMLVFINDITEM():New()
   st:_link_(lp,.F.)


RETURN 0

PROCEDURE onDummy()
LOCAL iMax := PCount()
LOCAL i
LOCAL cText := ""
LOCAL xValue

   FOR i := 1 TO iMax -1
      cText += Var2Char( PValue( i ) ) + CHR(9)
   NEXT
   cText += Var2Char( PValue( iMax ) )

   SET CONSOLE OFF
   SET ALTER ON

   ? cText

   SET ALTER OFF
   SET CONSOLE ON

RETURN


//
// only add "aSource"
//
CLASS DXE_DataView FROM xbp_listview
   EXPORTED:
     VAR aSource

INLINE METHOD Init( oParent,oOwner,aPos,aSize,aPresParam,lVisible,nView )
   ::xbp_listview:Init( oParent,oOwner,aPos,aSize,aPresParam,lVisible )
   ::aSource := {}
RETURN Self

INLINE METHOD Create( oParent,oOwner,aPos,aSize,aPresParam,lVisible )
   ::xbp_listview:Create( oParent,oOwner,aPos,aSize,aPresParam,lVisible )
RETURN Self

ENDCLASS

*
*
*